/*
 * DBMSConnection.java
 * Classe per l'interfacciamento con un DBMS generico
 */

/*
 * Corso di Basi di Dati 2004/2005
 * Prof. Angelo Chianese, Ing. Vincenzo Moscato
 */

import java.sql.*;
import java.util.*;

class DBMSConnection 
{
    protected String class_driver;  
    protected String url_connect;
    protected Connection conn;              
    protected Statement SQLStatement;      
    protected ResultSet rsQuery;            
    protected CallableStatement  cstmt;
    public static int max_rs_dim;
    protected String Password;
    protected String User;
      
    DBMSConnection () {
        url_connect="";
        class_driver="";
        User="";
        Password="";
        max_rs_dim=1000;
    }
            
    protected int connect () {
        System.out.println("Trying RDBMS Connection...");
        try{
            Class.forName(class_driver);
            conn = DriverManager.getConnection(url_connect,User,Password);
            System.out.println("Connection has been allowed...");
            return 1;
        }
        catch(java.lang.Exception exc){
            System.out.println("Class Driver ERROR " + exc.toString());       
            return 0;
        }
    }
    
    protected Vector[] selectquery_to_Matrix (String inputquery, int tuple_num) {
        try{
            SQLStatement = conn.createStatement();
            rsQuery = SQLStatement.executeQuery(inputquery);
            ResultSetMetaData rsmd = rsQuery.getMetaData();
            int nCols = rsmd.getColumnCount();
            int tuple_index=0;            
            Vector[] query_result= new Vector[tuple_num];
            while(rsQuery.next()){
                 Vector tuple=new Vector();
                 for(int ctCol = 0; ctCol < nCols; ctCol++)
                    tuple.addElement(rsQuery.getObject(ctCol+1));
                query_result[tuple_index]=tuple;
                tuple_index++;
            } 
            if(rsQuery != null) rsQuery.close();
            if(SQLStatement != null) SQLStatement.close(); 
            return query_result;
        }
        catch(java.lang.Exception exc){
            System.out.println("SQL ERROR " + exc.toString());
            return null;
        }        
    }
       
    protected Vector selectquery_to_Vector (String inputquery) {
        try{
            SQLStatement = conn.createStatement();
            rsQuery = SQLStatement.executeQuery(inputquery);
            ResultSetMetaData rsmd = rsQuery.getMetaData();
            int nCols = rsmd.getColumnCount();
            Vector query_result=new Vector();
            String str=new String("");
            while(rsQuery.next()){
                str="";
                for(int ctCol = 0; ctCol < nCols; ctCol++){
                    str = str + rsQuery.getString(ctCol+1)+" ";
                }
                query_result.addElement(str);
            } 
            if(rsQuery != null) rsQuery.close();
            if(SQLStatement != null) SQLStatement.close();
            return query_result;
        }
        catch(java.lang.Exception exc){
            System.out.println("SQL ERROR " + exc.toString()); 
            return null;
        }
    }
    
    protected String selectquery_to_String (String inputquery) {
        try{
            SQLStatement = conn.createStatement();
            rsQuery = SQLStatement.executeQuery(inputquery);
            ResultSetMetaData rsmd = rsQuery.getMetaData();
            int nCols = rsmd.getColumnCount();
            String query_result=new String();
            while(rsQuery.next()){
                for(int ctCol = 0; ctCol < nCols; ctCol++)
                    query_result = query_result + rsQuery.getString(ctCol+1)+" ";
                query_result=query_result+"\n";
            } 
            if(rsQuery != null) rsQuery.close();
            if(SQLStatement != null) SQLStatement.close();
            return query_result;
        }
        catch(java.lang.Exception exc){
            System.out.println("SQL ERROR " + exc.toString());       
            return null;
        }   
    }
    
    protected Vector Table_info (String table_name) {
        try{
            SQLStatement = conn.createStatement();
            rsQuery = SQLStatement.executeQuery("select * from " + table_name);
            ResultSetMetaData rsmd = rsQuery.getMetaData();
            int nCols = rsmd.getColumnCount();
            Vector coloumn_names=new Vector();
            for(int ctCol = 0; ctCol < nCols; ctCol++)
                    coloumn_names.addElement(rsmd.getColumnName(ctCol+1));
            if(rsQuery != null) rsQuery.close();
            if(SQLStatement != null) SQLStatement.close();
            return coloumn_names;
        }
        catch(java.lang.Exception exc){
            System.out.println("SQL ERROR " + exc.toString());       
            return null;
        }
    }
    
    protected void updatequery (String inputquery) {
        try{
            SQLStatement = conn.createStatement();
            SQLStatement.executeUpdate(inputquery);
            if(SQLStatement != null) SQLStatement.close();
        }
        catch(java.lang.Exception exc){
            System.out.println("SQL ERROR " + exc.toString());       
        }
    }
    
    protected int countquery (String inputquery) {
        int out_cnt=0;
        try{
            SQLStatement = conn.createStatement();
            rsQuery = SQLStatement.executeQuery(inputquery);
            while(rsQuery.next())
                out_cnt++;
            if(rsQuery != null) rsQuery.close();
            if(SQLStatement != null) SQLStatement.close();
            return out_cnt;
        }
        catch(java.lang.Exception exc){
            System.out.println("SQL ERROR " + exc.toString()); 
            return -1;
        }
    }
        
    protected void close_connection () {
        try{
            if(conn != null) { 
                conn.close();
                System.out.println("Connection has been closed...");
            }
            else
                System.out.println("Warning: Any Connection had been opened...");
        }
        catch(java.lang.Exception exc){
            System.out.println("ERROR IN CLOSING DB CONNECTION" + exc.toString());       
        }
    }
   
}