/*
 * OracleConnection.java
 * Classe derivata da DBMSConnection 
 * per l'interfacciamento con un DBMS ORACLE
 */

/*
 * Corso di Basi di Dati 2004/2005
 * Prof. Angelo Chianese, Ing. Vincenzo Moscato
 */

import java.sql.*;
import javax.naming.*;
import javax.sql.*;
import java.util.*;

public class OracleConnection extends DBMSConnection
{
    private String Ip_Server;
    private String Port;
    private String DB_Service;
    Properties env;
  
    
    OracleConnection () {
        class_driver= "oracle.jdbc.driver.OracleDriver";
        url_connect = "jdbc:oracle:thin:@";
    }
    
    void set_conn_parameters (String service, String ip, String user, String pwd, String port) {
        Password=pwd;
        Ip_Server=ip;
        Port=port;
        User=user;
        DB_Service=service;
        url_connect = url_connect + Ip_Server + ":" + port + ":" + DB_Service;
    }
    
    void set_conn_properties() {
        try {
            conn.setAutoCommit(true);
            conn.setTransactionIsolation(Connection.TRANSACTION_READ_COMMITTED);
        }
        catch(java.lang.Exception exc) {
            System.out.println("CONNECTION SETTINGS ERROR " + exc.toString()); 
        }
    }

    void StoredProcedure_Call(String proc_name, String [] param_values, int [] param_types) {
        cstmt=null;
        int param_num=param_values.length;  
        try {
            System.out.println("Calling Stored Procedure...");
            cstmt = conn.prepareCall(proc_name);
            for (int i=0;i<param_num;i++) {
                switch (param_types[i]) {
                    case (1):
                        cstmt.setString(i+1,param_values[i]);
                        break;
                    case (2):
                        cstmt.setInt(i+1,Integer.parseInt(param_values[i]));
                        break;
                    case (3):
                        cstmt.setDouble(i+1,Float.parseFloat(param_values[i]));                    
                        break;
                    case (4):
                        cstmt.setDate(i+1,java.sql.Date.valueOf(param_values[i]));                    
                        break;
                }
            }   
            cstmt.execute();
            cstmt.close();
            System.out.println("Procedure Executed");
        } catch(java.lang.Exception exc){
            System.out.println("SQL ERROR " + exc.toString()); 
        }
    }
    
} 