/*
 * Try_Connection_Form.java
 * Classe di prova usata per testare l'interfecciamento
 * verso vari DBMS
 */

/*
 * Corso di Basi di Dati 2004/2005
 * Prof. Angelo Chianese, Ing. Vincenzo Moscato
 */


import java.awt.*;
import javax.swing.*;
import java.util.*;

public class Try_Connection_Form extends javax.swing.JFrame {
    
    public static int WIDTH=400; 
    public static int HEIGTH=500;
    public static String TITLE="DBMS Connection";
    
    private javax.swing.JLabel Text_label1=new JLabel("Testing a DBMS Connection");
    private javax.swing.JLabel Text_label2=new JLabel("Select a supported DBMS:");
    private javax.swing.JLabel Text_label3=new JLabel("Insert the Database Service:");
    private javax.swing.JLabel Text_label4=new JLabel("Insert the Connection User:");
    private javax.swing.JLabel Text_label5=new JLabel("Insert the Access Password:");
    private javax.swing.JLabel Text_label6=new JLabel("Insert the name of Target Table:");    
    private javax.swing.JLabel Text_label7=new JLabel("Insert the IP Adress of Server:");    
    private javax.swing.JLabel Text_label8=new JLabel("Insert the Listening Port of Server:");    
    private javax.swing.JComboBox DBMS_ComboBox=new JComboBox();
    private javax.swing.JTextField DS_TextField=new JTextField();
    private javax.swing.JPasswordField Pwd_TextField=new JPasswordField();
    private javax.swing.JTextField User_TextField=new JTextField();
    private javax.swing.JTextField Table_TextField=new JTextField();
    private javax.swing.JTextField IP_TextField=new JTextField();
    private javax.swing.JTextField Port_TextField=new JTextField();
    private javax.swing.JTable Query_Table=new JTable();
    private javax.swing.JButton Try_Button=new JButton("Try!!!");
    private javax.swing.JButton Reset_Button=new JButton("Reset All");
    private JScrollPane scroll=new JScrollPane();
    public String[] DBMS_list={"<Select a DBMS>","Access","MySQL","Oracle 9i"};
    
    public Try_Connection_Form() {
        super(TITLE);
        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setSize(WIDTH,HEIGTH);
        setBackground(Color.gray);
        setResizable(false);
        Try_Button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Try_Connection(evt);
            }
        });
        Reset_Button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Reset(evt);
            }
        });
        init_components();
    }
    
    private void init_components() {
        
        DBMS_ComboBox.setEnabled(true);
        DS_TextField.setEditable(true);
        Table_TextField.setEditable(true);
        Reset_Button.setEnabled(false);
        Try_Button.setEnabled(true);
        Pwd_TextField.setEditable(true);
        User_TextField.setEditable(true);
        IP_TextField.setEditable(true);
        Port_TextField.setEditable(true);
        
        DS_TextField.setText("");        
        Pwd_TextField.setText("");        
        User_TextField.setText("");        
        Table_TextField.setText("");        
        IP_TextField.setText("");        
        Port_TextField.setText("");        
        
        getContentPane().remove(scroll);  
        getContentPane().repaint();
        getContentPane().setLayout(null);
        
        getContentPane().add(Text_label1);
        Text_label1.setFont(new java.awt.Font("Verdana", 1, 11));
        Text_label1.setBounds(90, 10, 200, 20);
        
        getContentPane().add(Text_label2);
        Text_label2.setFont(new java.awt.Font("Verdana", 0, 11));
        Text_label2.setBounds(10, 40, 200, 20);
        
        DBMS_ComboBox=new JComboBox(DBMS_list);
        getContentPane().add(DBMS_ComboBox);
        DBMS_ComboBox.setFont(new java.awt.Font("Verdana", 0, 11));
        DBMS_ComboBox.setBounds(230, 40, 120, 20);
        
        getContentPane().add(Text_label3);
        Text_label3.setFont(new java.awt.Font("Verdana", 0, 11));
        Text_label3.setBounds(10, 70, 220, 20);
        
        getContentPane().add(DS_TextField);
        DS_TextField.setFont(new java.awt.Font("Verdana", 0, 11));
        DS_TextField.setBounds(230, 70, 120, 20);
        
        getContentPane().add(Text_label4);
        Text_label4.setFont(new java.awt.Font("Verdana", 0, 11));
        Text_label4.setBounds(10, 100, 220, 20);
        
        getContentPane().add(User_TextField);
        User_TextField.setFont(new java.awt.Font("Verdana", 0, 11));
        User_TextField.setBounds(230, 100, 120, 20);
        
        getContentPane().add(Text_label5);
        Text_label5.setFont(new java.awt.Font("Verdana", 0, 11));
        Text_label5.setBounds(10, 130, 220, 20);
        
        getContentPane().add(Pwd_TextField);
        Pwd_TextField.setFont(new java.awt.Font("Verdana", 0, 11));
        Pwd_TextField.setBounds(230, 130, 120, 20);
        
        getContentPane().add(Text_label6);
        Text_label6.setFont(new java.awt.Font("Verdana", 0, 11));
        Text_label6.setBounds(10, 160, 220, 20);
        
        getContentPane().add(Table_TextField);
        Table_TextField.setFont(new java.awt.Font("Verdana", 0, 11));
        Table_TextField.setBounds(230, 160, 120, 20);
        
        getContentPane().add(Text_label7);
        Text_label7.setFont(new java.awt.Font("Verdana", 0, 11));
        Text_label7.setBounds(10, 190, 220, 20);
        
        getContentPane().add(IP_TextField);
        IP_TextField.setFont(new java.awt.Font("Verdana", 0, 11));
        IP_TextField.setBounds(230, 190, 120, 20);
        
        getContentPane().add(Text_label8);
        Text_label8.setFont(new java.awt.Font("Verdana", 0, 11));
        Text_label8.setBounds(10, 220, 220, 20);
        
        getContentPane().add(Port_TextField);
        Port_TextField.setFont(new java.awt.Font("Verdana", 0, 11));
        Port_TextField.setBounds(230, 220, 120, 20);
        
        Try_Button.setBorderPainted(true);
        Try_Button.setFont(new java.awt.Font("Verdana", 1, 11));
        getContentPane().add(Try_Button);
        Try_Button.setBounds(130, 260, 120, 20);
        
        getContentPane().add(Reset_Button);
        Reset_Button.setFont(new java.awt.Font("Verdana", 1, 11));
        Reset_Button.setBounds(130, 430, 120, 20);
       
    }
        
    public void Try_Connection(java.awt.event.ActionEvent evt) {
        
        DBMS_ComboBox.setEnabled(false);
        DS_TextField.setEditable(false);
        Pwd_TextField.setEditable(false);
        User_TextField.setEditable(false);
        Table_TextField.setEditable(false);
        IP_TextField.setEditable(false);
        Port_TextField.setEditable(false);
        Reset_Button.setEnabled(true);
        Try_Button.setEnabled(false);
        
        String dbms_type=DBMS_ComboBox.getSelectedItem().toString();
        String database=DS_TextField.getText();
        String username=User_TextField.getText();
        String password=Pwd_TextField.getText();
        String tabella=Table_TextField.getText();
        String server=IP_TextField.getText();
        String port=Port_TextField.getText();
        
        int go=0, counter=0;
        Vector[] ris=new Vector[1];
        Vector field=new Vector();
        
        if ((dbms_type.compareTo("Oracle 9i"))==0) {
            System.out.println("ORACLE CONNECTION");
            OracleConnection db_interface=new OracleConnection();
            db_interface.set_conn_parameters(database, server, username, password, port);
            go=db_interface.connect();
            if (go==1) {
                db_interface.set_conn_properties();
                counter=db_interface.countquery("select * from " + tabella);
                if (counter<=db_interface.max_rs_dim) { 
                    ris=new Vector[counter];
                    ris=db_interface.selectquery_to_Matrix("select * from " + tabella,counter);
                    field=db_interface.Table_info(tabella);
                }
                else
                    System.out.println("Dimension of Result Set is too large: refine the query");
                db_interface.close_connection();                    
            }
        }
        if ((dbms_type.compareTo("MySQL"))==0) {
            System.out.println("MYSQL CONNECTION");
            MySQLConnection db_interface=new MySQLConnection();
            db_interface.set_conn_parameters(database, server, username, password, port);
            go=db_interface.connect();
            if (go==1) {
                db_interface.set_conn_properties();
                counter=db_interface.countquery("select * from " + tabella);
                if (counter<=db_interface.max_rs_dim) {
                    ris=new Vector[counter];
                    ris=db_interface.selectquery_to_Matrix("select * from " + tabella,counter);
                    field=db_interface.Table_info(tabella);
                } else 
                    System.out.println("Dimension of Result Set is too large: refine the query");
            }
                db_interface.close_connection();                    
        }
        if ((dbms_type.compareTo("Access"))==0) {
            System.out.println("ACCESS CONNECTION");
            AccessConnection db_interface=new AccessConnection();
            db_interface.set_conn_parameters(database);
            go=db_interface.connect();
            if (go==1) {
                counter=db_interface.countquery("select * from " + tabella + ";");
                if (counter<=db_interface.max_rs_dim) {
                    ris=new Vector[counter];
                    ris=db_interface.selectquery_to_Matrix("select * from " + tabella + ";",counter);
                    field=db_interface.Table_info(tabella);
                } else 
                    System.out.println("Dimension of Result Set is too large: refine the query");
            }
            db_interface.close_connection();
        }
            
        Object [][] cells=new Object [counter][field.size()];
        String[] table_fields=new String[field.size()];
        for (int i=0;i<counter;i++)
            for (int j=0;j<field.size();j++) {
                cells[i][j]=ris[i].elementAt(j);
                table_fields[j]=field.elementAt(j).toString();
        }        
        Query_Table=new JTable(cells,table_fields);
        scroll=new JScrollPane(Query_Table);
        getContentPane().add(scroll);
        scroll.setFont(new java.awt.Font("Verdana", 0, 11));
        scroll.setBounds(20, 310, 350, 90);        
     }
    
    public void Reset(java.awt.event.ActionEvent evt) {
        init_components();
     }
    
    
     public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Try_Connection_Form().setVisible(true);
            }
        });
    }        
}
